package cn.iocoder.yudao.module.member.service.configdata;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.member.controller.admin.configdata.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.configdata.ConfigDataDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.member.dal.mysql.configdata.ConfigDataMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.member.enums.ErrorCodeConstants.*;

/**
 * 配置数据 Service 实现类
 *
 * @author 秦俊旗
 */
@Service
@Validated
public class ConfigDataServiceImpl implements ConfigDataService {

    @Resource
    private ConfigDataMapper configDataMapper;

    @Override
    public Long createConfigData(ConfigDataSaveReqVO createReqVO) {
        // 插入
        ConfigDataDO configData = BeanUtils.toBean(createReqVO, ConfigDataDO.class);
        configDataMapper.insert(configData);
        // 返回
        return configData.getId();
    }

    @Override
    public void updateConfigData(ConfigDataSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigDataExists(updateReqVO.getId());
        // 更新
        ConfigDataDO updateObj = BeanUtils.toBean(updateReqVO, ConfigDataDO.class);
        configDataMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigData(Long id) {
        // 校验存在
        validateConfigDataExists(id);
        // 删除
        configDataMapper.deleteById(id);
    }

    private void validateConfigDataExists(Long id) {
        if (configDataMapper.selectById(id) == null) {
            throw exception(CONFIG_DATA_NOT_EXISTS);
        }
    }

    @Override
    public ConfigDataDO getConfigData(Long id) {
        return configDataMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigDataDO> getConfigDataPage(ConfigDataPageReqVO pageReqVO) {
        return configDataMapper.selectPage(pageReqVO);
    }

    @Override
    public ConfigDataDO getConfigData(String label, String dictType) {
        return configDataMapper.selectOne(Wrappers.<ConfigDataDO>lambdaQuery()
                .eq(ConfigDataDO::getLabel,label).eq(ConfigDataDO::getDictType,dictType));
    }

    @Override
    public List<ConfigDataDO> getConfigDataList(String dictType) {
        return configDataMapper.selectList(Wrappers.<ConfigDataDO>lambdaQuery()
                .eq(ConfigDataDO::getDictType,dictType));
    }
}